All of lore.kernel.org
 help / color / mirror / Atom feed
From: Amir Goldstein <amir73il@gmail.com>
To: Eryu Guan <eguan@redhat.com>
Cc: Miklos Szeredi <miklos@szeredi.hu>,
	linux-unionfs@vger.kernel.org, fstests@vger.kernel.org
Subject: [PATCH 4/5] overlay: test cases that force read-only mount
Date: Tue, 11 Jul 2017 22:52:05 +0300	[thread overview]
Message-ID: <1499802726-11045-5-git-send-email-amir73il@gmail.com> (raw)
In-Reply-To: <1499802726-11045-1-git-send-email-amir73il@gmail.com>

- Mount with no upper dir
- Failure to create work dir

Verify that overlay is mounted read-only and that it cannot
be remounted rw.

Signed-off-by: Amir Goldstein <amir73il@gmail.com>
---
 tests/overlay/035     | 87 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/035.out |  5 +++
 tests/overlay/group   |  1 +
 3 files changed, 93 insertions(+)
 create mode 100755 tests/overlay/035
 create mode 100644 tests/overlay/035.out

diff --git a/tests/overlay/035 b/tests/overlay/035
new file mode 100755
index 0000000..e3fbed7
--- /dev/null
+++ b/tests/overlay/035
@@ -0,0 +1,87 @@
+#! /bin/bash
+# FS QA Test 035
+#
+# Test cases that force read-only mount
+#
+# - No upper dir
+# - Failure to create work dir
+#
+#-----------------------------------------------------------------------
+# Copyright (C) 2017 CTERA Networks. All Rights Reserved.
+# Author: Amir Goldstein <amir73il@gmail.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	$CHATTR_PROG -i $workdir
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+_require_chattr i
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Create multiple lowerdirs and upperdir, workdir
+lowerdir1=$OVL_BASE_SCRATCH_MNT/lower1
+lowerdir2=$OVL_BASE_SCRATCH_MNT/lower2
+upperdir=$OVL_BASE_SCRATCH_MNT/upper
+workdir=$OVL_BASE_SCRATCH_MNT/workdir
+mkdir -p $lowerdir1 $lowerdir2 $upperdir $workdir
+
+# Mount overlay with lower layers only.
+# Verify that overlay is mounted read-only and that it cannot be remounted rw.
+$MOUNT_PROG -t overlay -o"lowerdir=$lowerdir2:$lowerdir1" \
+			$OVL_BASE_SCRATCH_MNT $SCRATCH_MNT
+touch $SCRATCH_MNT/foo 2>&1 | _filter_scratch
+$MOUNT_PROG $SCRATCH_MNT -o"remount,rw" 2>&1 | _filter_scratch
+$UMOUNT_PROG $SCRATCH_MNT
+
+# Make workdir immutable to prevent workdir re-create on mount
+$CHATTR_PROG +i $workdir
+
+# Mount overlay with upper and wordir and expect failure to re-create workdir.
+# Verify that overlay is mounted read-only and that it cannot be remounted rw.
+_overlay_mount_dirs $lowerdir2 $upperdir $workdir \
+		    $OVL_BASE_SCRATCH_MNT $SCRATCH_MNT
+touch $SCRATCH_MNT/bar 2>&1 | _filter_scratch
+$MOUNT_PROG $SCRATCH_MNT -o"remount,rw" 2>&1 | _filter_scratch
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/035.out b/tests/overlay/035.out
new file mode 100644
index 0000000..5a5f677
--- /dev/null
+++ b/tests/overlay/035.out
@@ -0,0 +1,5 @@
+QA output created by 035
+touch: cannot touch 'SCRATCH_MNT/foo': Read-only file system
+mount: cannot remount SCRATCH_DEV read-write, is write-protected
+touch: cannot touch 'SCRATCH_MNT/bar': Read-only file system
+mount: cannot remount SCRATCH_DEV read-write, is write-protected
diff --git a/tests/overlay/group b/tests/overlay/group
index 356a322..87e3aaf 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -37,3 +37,4 @@
 032 auto quick copyup hardlink
 033 auto quick copyup hardlink
 034 auto quick copyup hardlink
+035 auto quick mount
-- 
2.7.4


  parent reply	other threads:[~2017-07-11 19:52 UTC|newest]

Thread overview: 15+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-07-11 19:52 [PATCH 0/5] overlay mount tests Amir Goldstein
2017-07-11 19:52 ` [PATCH 1/5] overlay/014: remove unneeded require and include Amir Goldstein
2017-07-11 19:52 ` [PATCH 2/5] overlay/014: fix test with inodes index enabled Amir Goldstein
2017-07-12 10:36   ` Eryu Guan
2017-07-12 10:45     ` Amir Goldstein
2017-07-11 19:52 ` [PATCH 3/5] overlay: create overlay/mount test group Amir Goldstein
2017-07-11 19:52 ` Amir Goldstein [this message]
2017-07-12 10:31   ` [PATCH 4/5] overlay: test cases that force read-only mount Eryu Guan
2017-07-12 10:37     ` Amir Goldstein
2017-07-11 19:52 ` [PATCH 5/5] overlay: test mount error cases with exclusive directories Amir Goldstein
2017-07-12 10:47   ` Eryu Guan
2017-07-12 11:08     ` Amir Goldstein
2017-07-12 11:46       ` Eryu Guan
2017-07-12 11:53         ` Amir Goldstein
2017-07-12 12:07   ` [PATCH v2 " Amir Goldstein

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1499802726-11045-5-git-send-email-amir73il@gmail.com \
    --to=amir73il@gmail.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-unionfs@vger.kernel.org \
    --cc=miklos@szeredi.hu \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.